//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/plugins/PBrowserStreamParent.h"

#include "mozilla/plugins/PPluginInstanceParent.h"

typedef IPC::Message Message;
typedef mozilla::ipc::RPCChannel Channel;
typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
typedef base::ProcessHandle ProcessHandle;
typedef mozilla::plugins::PPluginInstanceParent PPluginInstanceParent;
typedef mozilla::ipc::ActorHandle ActorHandle;
typedef mozilla::ipc::Shmem Shmem;
typedef mozilla::plugins::Buffer Buffer;
typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

namespace mozilla {
namespace plugins {


void
PBrowserStreamParent::ActorDestroy(ActorDestroyReason why)
{
}

PBrowserStreamParent::PBrowserStreamParent() :
    mId(0)
{
    MOZ_COUNT_CTOR(PBrowserStreamParent);
}

PBrowserStreamParent::~PBrowserStreamParent()
{
    MOZ_COUNT_DTOR(PBrowserStreamParent);
}

PPluginInstanceParent*
PBrowserStreamParent::Manager()
{
    return static_cast<PPluginInstanceParent*>(mManager);
}

bool
PBrowserStreamParent::SendWrite(
        const int32_t& offset,
        const Buffer& data,
        const uint32_t& newlength)
{
    PBrowserStream::Msg_Write* msg;

    msg = new PBrowserStream::Msg_Write(offset, data, newlength);
    (msg)->set_routing_id(mId);



    if (mozilla::ipc::LoggingEnabled()) {
        (msg)->Log("[PBrowserStreamParent] Sending ", stderr);
    }

    bool __sendok = (mChannel)->Send(msg);
    return __sendok;
}

bool
PBrowserStreamParent::CallNPP_StreamAsFile(const nsCString& fname)
{
    PBrowserStream::Msg_NPP_StreamAsFile* msg;

    msg = new PBrowserStream::Msg_NPP_StreamAsFile(fname);
    (msg)->set_routing_id(mId);
    (msg)->set_rpc();


    Message reply;

    if (mozilla::ipc::LoggingEnabled()) {
        (msg)->Log("[PBrowserStreamParent] Sending ", stderr);
    }

    bool __sendok = (mChannel)->Call(msg, (&(reply)));
    if ((!(__sendok))) {
        return false;
    }

    if (mozilla::ipc::LoggingEnabled()) {
        (static_cast<const PBrowserStream::Reply_NPP_StreamAsFile*>((&(reply))))->Log("[PBrowserStreamParent] Received reply ", stderr);
    }

    bool __readok = PBrowserStream::Reply_NPP_StreamAsFile::Read((&(reply)));

    return __readok;
}

bool
PBrowserStreamParent::SendNPP_DestroyStream(const NPReason& reason)
{
    PBrowserStream::Msg_NPP_DestroyStream* msg;

    msg = new PBrowserStream::Msg_NPP_DestroyStream(reason);
    (msg)->set_routing_id(mId);



    if (mozilla::ipc::LoggingEnabled()) {
        (msg)->Log("[PBrowserStreamParent] Sending ", stderr);
    }

    bool __sendok = (mChannel)->Send(msg);
    return __sendok;
}

bool
PBrowserStreamParent::Send__delete__(PBrowserStreamParent* actor)
{
    if ((!(actor))) {
        return false;
    }

    if ((!(actor))) {
        return false;
    }

    PBrowserStream::Msg___delete__* msg;

    // serializing actor type
    ActorHandle actor_handle_1;
    if ((!(actor))) {
        NS_ERROR("NULL actor value passed to non-nullable param");
        return false;
    }
    else {
        if ((1) == ((actor)->mId)) {
            NS_RUNTIMEABORT("actor has been delete'd");
        }
        else {
            (actor_handle_1).mId = (actor)->mId;
        }
    }

    msg = new PBrowserStream::Msg___delete__(actor_handle_1);
    (msg)->set_routing_id((actor)->mId);


    if (mozilla::ipc::LoggingEnabled()) {
        (msg)->Log("[PBrowserStreamParent] Sending ", stderr);
    }

    bool __sendok = ((actor)->mChannel)->Send(msg);

    (actor)->Unregister((actor)->mId);
    (actor)->mId = 1;
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PBrowserStreamMsgStart, actor);
    return __sendok;
}

PBrowserStreamParent::Result
PBrowserStreamParent::OnMessageReceived(const Message& msg)
{
    switch ((msg).type()) {
    case PBrowserStream::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PBrowserStream::Msg_NPN_DestroyStream__ID:
        {
            (const_cast<Message&>(msg)).set_name("PBrowserStream::Msg_NPN_DestroyStream");
            if (mozilla::ipc::LoggingEnabled()) {
                (static_cast<const PBrowserStream::Msg_NPN_DestroyStream*>((&(msg))))->Log("[PBrowserStreamParent] Received ", stderr);
            }

            NPReason reason;
            bool __readok = PBrowserStream::Msg_NPN_DestroyStream::Read((&(msg)), (&(reason)));
            if ((!(__readok))) {
                return MsgPayloadError;
            }

            if ((!(RecvNPN_DestroyStream(reason)))) {
                return MsgValueError;
            }

            return MsgProcessed;
        }
    case PBrowserStream::Msg_StreamDestroyed__ID:
        {
            (const_cast<Message&>(msg)).set_name("PBrowserStream::Msg_StreamDestroyed");
            if (mozilla::ipc::LoggingEnabled()) {
                (static_cast<const PBrowserStream::Msg_StreamDestroyed*>((&(msg))))->Log("[PBrowserStreamParent] Received ", stderr);
            }

            bool __readok = PBrowserStream::Msg_StreamDestroyed::Read((&(msg)));
            if ((!(__readok))) {
                return MsgPayloadError;
            }

            if ((!(RecvStreamDestroyed()))) {
                return MsgValueError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

PBrowserStreamParent::Result
PBrowserStreamParent::OnMessageReceived(
        const Message& msg,
        Message*& reply)
{
    return MsgNotKnown;
}

PBrowserStreamParent::Result
PBrowserStreamParent::OnCallReceived(
        const Message& msg,
        Message*& reply)
{
    switch ((msg).type()) {
    case PBrowserStream::Msg_NPN_RequestRead__ID:
        {
            (const_cast<Message&>(msg)).set_name("PBrowserStream::Msg_NPN_RequestRead");
            if (mozilla::ipc::LoggingEnabled()) {
                (static_cast<const PBrowserStream::Msg_NPN_RequestRead*>((&(msg))))->Log("[PBrowserStreamParent] Received ", stderr);
            }

            IPCByteRanges ranges;
            bool __readok = PBrowserStream::Msg_NPN_RequestRead::Read((&(msg)), (&(ranges)));
            if ((!(__readok))) {
                return MsgPayloadError;
            }

            NPError result;
            int32 __id = mId;
            if ((!(AnswerNPN_RequestRead(ranges, (&(result)))))) {
                return MsgValueError;
            }

            reply = new PBrowserStream::Reply_NPN_RequestRead(result);
            (reply)->set_routing_id(__id);
            (reply)->set_rpc();
            (reply)->set_reply();

            if (mozilla::ipc::LoggingEnabled()) {
                (static_cast<const PBrowserStream::Reply_NPN_RequestRead*>(reply))->Log("[PBrowserStreamParent] Sending reply ", stderr);
            }
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

bool
PBrowserStreamParent::OnReplyTimeout()
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

void
PBrowserStreamParent::OnChannelClose()
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

void
PBrowserStreamParent::OnChannelError()
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

int32
PBrowserStreamParent::Register(ChannelListener* aRouted)
{
    return (mManager)->Register(aRouted);
}

int32
PBrowserStreamParent::RegisterID(
        ChannelListener* aRouted,
        int32 aId)
{
    return (mManager)->RegisterID(aRouted, aId);
}

ChannelListener*
PBrowserStreamParent::Lookup(int32 aId)
{
    return (mManager)->Lookup(aId);
}

void
PBrowserStreamParent::Unregister(int32 aId)
{
    return (mManager)->Unregister(aId);
}

void
PBrowserStreamParent::RemoveManagee(
        int32 aProtocolId,
        ChannelListener* aListener)
{
    switch (aProtocolId) {
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
}

ProcessHandle
PBrowserStreamParent::OtherProcess() const
{
    return (mManager)->OtherProcess();
}

void
PBrowserStreamParent::FatalError(const char* const msg) const
{
    NS_ERROR("IPDL error:");
    NS_ERROR(msg);

    NS_ERROR("[PBrowserStreamParent] killing child side as a result");

    if ((!(base::KillProcess(OtherProcess(), base::PROCESS_END_KILLED_BY_USER, false)))) {
        NS_ERROR("  may have failed to kill child!");
    }
}

void
PBrowserStreamParent::DestroySubtree(ActorDestroyReason why)
{
    ActorDestroy(why);
}

void
PBrowserStreamParent::DeallocSubtree()
{
}



} // namespace plugins
} // namespace mozilla
